<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Structured Annotes</TITLE>
<link href="suif1_73.html" rel=Next>
<link href="suif1_71.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_71.html">previous</A>, <A HREF="suif1_73.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC72" HREF="suif1_toc.html#TOC72">Structured Annotations</A></H2>
<P>
<A NAME="IDX554"></A>
<A NAME="IDX555"></A>

</P>
<P>
In many cases, flat annotations are cumbersome to use because the fields
in the <CODE>immed</CODE> value list are unlabeled and difficult to access.
With <STRONG>structured annotations</STRONG>, the data is held in a user-defined
structure.  You can access this structured data by using the <CODE>data</CODE>
method and casting the result to the desired type.  It may be helpful to
define macros to perform the type casts.

</P>
<P>
An important restriction on structured annotations is that if they are
to be stored in SUIF files, they are stored as <CODE>immed</CODE> lists.
Therefore, if you wish to write such an annotation to a file, you must
provide the annotation manager with functions to convert back and
forth between the <CODE>immed</CODE> lists and the structured data.  When a
structured annotation is first read from an input file, the annotation
manager applies the function to convert the <CODE>immed</CODE> list to your
data structure.  Similarly, when the annotation is written out, the
manager applies the function to convert it back to a list of
<CODE>immed</CODE> values.

</P>
<P>
The data in a structured annotation that defines a conversion function
must always be maintained in a form that can be converted to an
<CODE>immed</CODE> list.  This is necessary because the library occasionally
needs to flatten annotations so that it can update the contents.  For
example, when an annotation containing references to local symbols is
moved to another scope, the symbols may need to be updated.  When this
occurs, the library also converts the data back to its structured form
after it has been updated.

</P>
<P>
Just as the library needs to temporarily flatten structured annotations,
you may need to do the same.  The <CODE>immeds</CODE> and <CODE>set_immeds</CODE>
methods make this task much easier.  The <CODE>immeds</CODE> method returns
the annotation data represented as an <CODE>immed</CODE> list.  For a
structured annotation, it does this by using the conversion function
registered with the annotation manager to convert the structure to a
flat list.  Note however that the result is a pointer to a new list,
whereas for flat annotations, it is a pointer to the actual annotation
data.  Similarly, the <CODE>set_immeds</CODE> method replaces the annotation
data with the data in an <CODE>immed</CODE> list, but for structured
annotations, it first converts the data to the structured format.  It
does <EM>not</EM> try to deallocate the previous contents of the data
field, so you are responsible for handling that.  In summary, the
<CODE>immeds</CODE> and <CODE>set_immeds</CODE> methods allow you to access both
flat and structured annotation data as <CODE>immed</CODE> lists.  The only
difference is that for structured annotations the <CODE>immed</CODE> lists are
not the actual annotation data, and consequently you may need to
deallocate the duplicate data structures.

</P>
<P>
Besides the conversion functions, the annotation manager records
functions to deallocate and print the structured data.  Both of these
functions are optional.  If the data fields for a particular kind of
structured annotation contain pointers and you do not supply a function
to deallocate the storage that they reference, it is your responsibility
to ensure that that storage is deallocated elsewhere in your code.  (For
example, you may want to have the pointers all refer to entries in a
table that is deallocated separately.)

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_71.html">previous</A>, <A HREF="suif1_73.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
